################################################################
# Summon a lootable entity consisting of an animated_java rig
# and a data marker riding said rig's root.
#
#
# @as = marker[DM]
# @at = nd
# @args = {
#   type: string
#   variant: string
#   loot_table: string[loot_table]
#   hb_height: float
#   hb_width: float
# }
################################################################


# Summon the animated_java rig
$function animated_java:$(type)/summon/$(variant)
$ride @s mount @n[type=minecraft:item_display, tag=aj.$(type).root, predicate=!uf_api:.entity/.has/data_marker]

# Summon the hitbox
$function uf_api:.c_entity/.hitbox/.summon/only_interact {width:$(hb_width), height:$(hb_height), on_interact:"uf_entity:.c_entity/.lootable/on_interact"}

# Set marker's tags
tag @s add UF_ENTITY
tag @s add UF_ENTITY.on_interact
tag @s add UF_ENTITY.DM
tag @s add UF_ENTITY.DM-default
tag @s add UF_ENTITY.DM-lootable
$tag @s add UF_ENTITY.DM-lootable+$(type)

# Set marker's scores
scoreboard players set @s UF_ENTITY.TTL -1

# Set marker's data
$data modify entity @s data.type set value $(type)
$data modify entity @s data.variant set value $(variant)
data modify entity @s data.loot_table set from storage uf_entity:lootable summon.input.loot_table
$data modify entity @s data.hb_height set value $(hb_height)
$data modify entity @s data.hb_width set value $(hb_width)
data modify entity @s data.hitboxDM_UUID set from storage uf_entity:hitbox summon.output.DM_UUID